#include <bits/stdc++.h>

#define MAX 200
#define EPS 1e-6
#define MOD 1000000007
#define inf 0x3f3f3f3f
#define llinf 0x3f3f3f3f3f3f3f3f

#define fi first
#define se second
#define sz size()
#define pb push_back
#define ende '\n'

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define mset(x, y) memset(&x, (y), sizeof(x))

using namespace std; 

typedef long long ll;
typedef pair<int,int> ii;

int dist[MAX];
vector<ii> graph[MAX];

int dijkstra(int o, int d) {
  set<ii> pq;
  int u, v, wt;

  mset(dist, inf);

  dist[o] = 0;
  pq.insert(ii(0, o));

  while (pq.size() != 0) {
    u = pq.begin()->second;
    pq.erase(pq.begin());

    for (auto i : graph[u]) {
      v = i.first;
      wt = i.second;

      if (dist[v] > dist[u] + wt) {
        if (dist[v] != inf)
          pq.erase(pq.find(ii(dist[v], v)));

        dist[v] = dist[u] + wt;
        pq.insert(ii(dist[v], v));
      }
    }
  }

  return dist[d];
}

int main() {
  ios::sync_with_stdio(0);
  cin.tie(0);

  int n, m;
  while (cin >> n >> m && (n || m)) {
    for (int i = 1; i <= n; ++i) graph[i].clear();

    for (int i = 0; i < m; ++i) {
      int o, d, t; cin >> o >> d >> t;
      graph[o].pb(ii(d, t));
    }

    int s, t; cin >> s >> t;
    int ans = dijkstra(s, t);
    cout << ((ans == inf) ? -1 : ans) << ende;
  }

  return 0;
}
